#ifndef BUSSIM_ARC_H_INCLUDED
#define BUSSIM_ARC_H_INCLUDED


class BUSSIM_ARC_IN_LINE {
public:
    int LINE_ID;
    double x_offset;
    double y_offset;
    class BUSSIM_ARC_IN_LINE *next;
};

class BUSSIM_ARC {
public:
    int ID;                 // unique identifier
    int orig_node;          // refers to id of source BUSSIM_POINT of this arc
    int dest_node;          // refers to id of target BUSSIM_POINT of this arc

    int pos;                // only needed if arc is saved in line
    double length_screen;   // length on screen (scaled into [-1;1]x[-1;1] determined by Pythagoras

    int type;               // defines in which direction this arc shows

    class BUSSIM_ARC_IN_LINE *first_line;
    class BUSSIM_ARC_IN_LINE *last_line;
    int lines_on_arc;

    double orig_screen_x;   // coordinates on screen
    double orig_screen_y;
    double dest_screen_x;
    double dest_screen_y;

    BUSSIM_ARC();
    BUSSIM_ARC(int ID, int _ORIGIN, int _DESTINATION, double _ORIG_SCREEN_X, double _ORIG_SCREEN_Y, double _DEST_SCREEN_X, double _DEST_SCREEN_Y);
    ~BUSSIM_ARC();

    void print_on_screen(void);
    void update_length(void);
    void append_line(class BUSSIM_ARC_IN_LINE *_Ptr);
    void set_direction_type(void);
};

#endif // BUSSIM_ARC_H_INCLUDED
