#ifndef BUSSIM_POINT_H_INCLUDED
#define BUSSIM_POINT_H_INCLUDED

class BUSSIM_POINT {
public:
    int ID;                 // unique identifier of this point

    double world_x;         // the x-coordinate of this point in the real world
    double world_y;         // the y-ccordinate of this point in the real world

    double screen_x;        // the x-coordinate of this point on the screen
    double screen_y;        // the y-ccordinate of this point on the screen

    int label_pos;          // direction of label position from center of point
    double label_x_offset;  // horizontal distance of label from center of point
    double label_y_offset;  // vertical distance of label from center of point

    int type;               // regular or service stop

    BUSSIM_POINT();         // this is the default constructor
    BUSSIM_POINT(double _X, double _Y);     // this is an overloaded constructor to directly set the coordinates
    ~BUSSIM_POINT();       // this is the default constructor

    // this procedure calculates the coordinates of this point on the screen
    void calculate_screen_coordinates(class BUSSIM_NETWORK *_NET, double xmin, double xmax, double ymin, double ymax);

    // this procedure prints this point on the screen
    void print_on_screen(void);
    // this procedures prints the label of this point on the screen
    void print_on_screen_small(void);
    // this procedures also prints the label of this point on the screen - but in another kind
    void print_label_on_screen(void);
};

#endif // BUSSIM_POINT_H_INCLUDED
